=== lib/Target/AVR/TargetInfo/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_BINARY_DIR}/..
                     ${CMAKE_CURRENT_SOURCE_DIR}/.. )

add_llvm_component_library(LLVMAVRInfo
  AVRTargetInfo.cpp

  LINK_COMPONENTS
  MC
  Support

  ADD_TO_COMPONENT
  AVR
)

add_dependencies(LLVMAVRInfo AVRCommonTableGen)
